package assignment05;

/*
*  Assignment 05:
*    Circle: This class is adapted from assignment02.
*
*/

public class Circle {
	
	// Fields
	private Point center;   // center point
	private double r;   // radius
	private String name;
	private String color;

	// *Constructor*s
        // You should note that the Point object should be encapsulated by
        // the Circle. That's why a private object is created and 
        // maintained by the Circle. No matter how the coordinates for the 
        // center is sent to this class, a new Point object is created.
        // QUESTION: What other options are there? What is the diff?
        
        // *Contructor* (the method to follow for instantiating objects
        // Create a Circle at the specified coordinates and with the  
        //   given radius.
	public Circle(double x, double y, double r, String name, String color) {
		this.center = new Point(x,y);
		this.r = r;
		this.name = name;
		this.color = color;
	}
	
        // *constructor* - *overloading*
        // An alternative constructor when we have a Point as the center.
	public Circle(Point n, double r, String isim, String renk) {
                // the real WORK is done by the first constructor...
                // we only extract the coordinates here.
		this(n.x(), n.y(), r, isim, renk);
	}
        
	// Methods
	
	// where is the center of this circle?
	public Point center () {
		return center;
	}
	
	public void center (Point newCenter) {
		this.center = newCenter;
	}

	public double radius () {
		return r;
	}
	
	public void radius (double r) {
		this.r = r;
	}
	
	public String name () {
		return name;
	}
	
	public void name (String isim) {
		this.name = isim;
	}
	
	public String color () {
		return color;
	}
	
	public void color (String renk) {
		this.color = renk;
	}
	
	
        // Calculate the circumference of this circle
	public double circumference () {
                // no need to define temporary variables
                // (although we did in the first part)
		return 2 * Math.PI * r;
	}
	
	// Calculate the area of this circle
	public double area () {
		return Math.PI * r*r;
	}
	
        // Is the specified point inside or outside this circle?
        //   We measure the distance between the point and the center 
        //   and compare it with the radius. The answer is either true
        //   or false.
	public boolean isPointInside (double x_of_point, double y_of_point) {
		if (Circle.this.distance(x_of_point, y_of_point) < r)
			return true;
		else 
			return false;
	}
	
        // if the "client" has a Point object and wants to send
        // that directly, we should provide a more convenient
        // method: Another *Overloading* example
	public boolean isPointInside (Point n) {
		return Circle.this.isPointInside ( n.x(), n.y() );
	}
	
	public double distance (double nokta_x, double nokta_y) {
		double delta_x = nokta_x - this.center.x();
		double delta_y = nokta_y - this.center.y();
		return Math.sqrt(delta_x*delta_x + delta_y*delta_y);
	}

	public double distance (Point n) {
		return Circle.this.distance(n.x(), n.y());
	}
	
	
	public void printToScreen () {
		// NumberFormat/DecimalFormat classes
		//  they help us to display only a set number of digits 
		//  on screen. Example below:
		// (Not necessary for the assignment)
		java.text.DecimalFormat df = new java.text.DecimalFormat("0.000");
		java.text.DecimalFormatSymbols symbols = df.getDecimalFormatSymbols();
		symbols.setDecimalSeparator('.');
		df.setDecimalFormatSymbols(symbols);	
		
		//  If you do not use the above methods, do not forget to omit the df.format() method calls below.
		System.out.println(name + ": @(" + df.format(center.x()) + ", " + df.format(center.y()) + ") \tr=" + df.format(r)+ " \tcolor:" + color );
	}
	
}


