package assignment05;

/*
*  Assignment 5:
*    CircleApplication: 
*            Loops and arrays
*           
*
*/

public class CircleApplication {
	
	public static void main (String[] args) {
			String[] colors={"Red","Green","Blue","Yellow","Purple","Cyan",
        						"Orange","Brown","Black","White"}; 
			Circle[] circles = new Circle[100];
			Point center;
			double radius;
			String name, color;
			for (int i=0; i<100; i++) {                 // First create 100 Circles
				center = new Point( Math.random()*100, Math.random()*100);
				radius = Math.random()*100;
				if ( i<9 )
					name = new String ("Circle_00" + (i+1) );
				else if ( i<99 )
					name = new String ("Circle_0" + (i+1) );
				else
					name = new String ("Circle_" + (i+1) );
				color = colors[(int)(Math.random()*10)];		
				circles[i] = new Circle	( center, radius, name, color );
				circles[i].printToScreen();
			}
			
			System.out.println("--------------------");	// sum up the areas and calculate average 			
			double totalArea = 0;
			for (int i=0; i<100; i++) 
				totalArea = totalArea + circles[i].area();
			System.out.println(" TOTAL AREA: " + totalArea);
			System.out.println(" AVERAGE   : " + totalArea/100);
			
			System.out.println("--------------------");				
			System.out.println("Circle count grouped by color:");
			int[] colorCounters = new int[10];				// how many of each color?
			for (int i=0; i<10; i++) {					// we will use the order in the colors array
				System.out.print(colors[i] +":\t");
				for (int j=0; j<100; j++) {
					if ( colors[i].equals(circles[j].color()) )
						colorCounters[i]++;
				}
				System.out.println(colorCounters[i]);
			}
			
			System.out.println("--------------------");				
			Circle[] redCircles = new Circle[ colorCounters[0] ];   // we know red counter is in index 0
			for (int i=0, j=0; i<100; i++) {                        // we place a new set of markers 
				if ( circles[i].color().equals("Red") ) {       // on red circles
					redCircles[j] = circles[i];		//  NOTE: we are not copying objects
					j++;					// the objects in the reds[] array are
				}						// preserving their space in the circles[]
			}							// array
			// Now let's sort the markers in the reds[] array.
			boolean order_changed = true;
			Circle temp = null;
			while ( order_changed ) {					  // "bubble sort" algorithm
				order_changed = false;				  // until all elements are in correct order 	
				for (int i=0; i<redCircles.length-1 ;i++) {       // find the first element out of order and push it
					if ( redCircles[i].radius() > redCircles[i+1].radius() ) {   // towards its place by replacing
						temp = redCircles[i];             // its order with the next element.
						redCircles[i] = redCircles[i+1];
						redCircles[i+1] = temp;
						order_changed = true;
					}
				}
			}
			System.out.println("Red Circles:");
			for (int i=0; i<redCircles.length ;i++)
				System.out.println(redCircles[i].name() + " (r=" + redCircles[i].radius() + ")" );

			System.out.println("--------------------");				
			Point testPoint = new Point( Math.random()*100, Math.random()*100);
			Circle closest = circles[0];
			Circle farthest = circles[0];
			System.out.println ("To the point ("+testPoint.x()+", "+testPoint.y()+");");
			for (int i=1; i<100; i++) {													// mesafe() metodu kolaylik olarak
				if ( circles[i].distance(testPoint) < closest.distance(testPoint) )	// distance() method is added to Circle class
					closest = circles[i];
				else if (circles[i].distance(testPoint) > farthest.distance(testPoint) )
					farthest = circles[i];
			}
			System.out.println("Closest circle is:");
			System.out.println(closest.name() + " (distance= " + closest.distance(testPoint) + " )");
			System.out.println("Farthest circle is:");
			System.out.println(farthest.name() + " (distance= " + farthest.distance(testPoint) +" )");
	}
}


