package assignment05;



/*
*  Assignment 05:
*    CircleApplication2: 
*            Loops and Arrays
*            Alternative solutions -
*
*/

public class CircleApplication2 {

        // StringBuffer is useful.
	// This is only an example of how you can use it.
	private static String createName(int i) {
			StringBuffer sb = new StringBuffer("Circle_000");
			String s = String.valueOf(i);
			sb.replace(sb.length()-s.length(), sb.length(), s);
			return new String(sb);
	}
		
	public static void main (String[] args) {
			String[] colors={"Red","Green","Blue","Yellow","Purple","Cyan",
        						"Orange","Brown","Black","White"}; 
			int[] colorCounters = new int[10];		// how many of each color?
			int color;                                       // temporary variable 	
			double totalArea = 0;						
			Point testPoint = new Point( Math.random()*100, Math.random()*100);
			Circle[] circles = new Circle[100];
			Circle closest = null;
			Circle farthest = null;
			double closestDist = 1000;
			double farthestDist = 0;
			double distance = -1;  			// temp
						
			for (int i=0; i<100; i++) {		
				color = (int)(Math.random()*10);
				circles[i] = new Circle	( 	new Point( Math.random()*100, Math.random()*100 ), 
								Math.random()*100, 
								createName(i+1), 
								colors[color]  
							);
				circles[i].printToScreen();
				colorCounters[color]++;
				totalArea = totalArea + circles[i].area();
				distance = circles[i].distance(testPoint);
				if ( distance < closestDist ) {	
						closest = circles[i];
						closestDist = distance;
				}
				else if ( distance > farthestDist ) {
						farthest = circles[i];
						farthestDist = distance;
				}
			}
			
			System.out.println("--------------------");				
			System.out.println(" TOTAL AREA: " + totalArea);
			System.out.println(" AVERAGE   : " + totalArea/100);
			
			System.out.println("--------------------");				
			System.out.println("Circle counts groupd by color:");
			StringBuffer sb;
			for (int i=0; i<10; i++) {
				sb = new StringBuffer("          "); //just to align the numbers on screen
				System.out.println(sb.replace(0,colors[i].length(),colors[i]) + ": " + colorCounters[i]);
			}
			
			System.out.println("--------------------");				
			Circle[] reds = new Circle[ colorCounters[0] ];          // we know 0 is for red
			for (int i=0, j=0; i<100; i++) {			 // we place a new set of markers
				if ( circles[i].color().equals("Red") ) {    // on red circles
					reds[j] = circles[i];                    // NOTE: we are not copying objects
					j++;				 	 // the objects in the reds[] array are
				}						 // preserving their space in the circles[]
			}							 // array
			boolean order_changed = true;
			Circle temp = null;
			while ( order_changed ) {					  // "bubble sort" siralama algoritmasi
				order_changed = false;				  // elemanlar siralanana kadar tekrar ve tekrar 	
				for (int i=0; i<reds.length-1 ;i++) {       // sirayi bozan ilk eleman aranacak ve siradaki yerine
					if ( reds[i].radius() > reds[i+1].radius() ) {   // dogru adim adim ilerletilecek
						temp = reds[i];
						reds[i] = reds[i+1];
						reds[i+1] = temp;
						order_changed = true;
					}
				}
			}
			System.out.println("Red circles:");
			for (int i=0; i<reds.length ;i++)
				System.out.println(reds[i].name() + " (r=" + reds[i].radius() + ")" );

			System.out.println("--------------------");				
			System.out.println ("To the point ("+testPoint.x()+", "+testPoint.y()+");");
			System.out.println("Closest circle is:");
			System.out.println(closest.name() + " (distance= " + closest.distance(testPoint) + " )");
			System.out.println("Farthest circle is:");
			System.out.println(farthest.name() + " (distance= " + farthest.distance(testPoint) +" )");
	}
}


